// ******* This is a computer generated file *******
// ******* DO NOT HAND EDIT ************************
#include "fe.h"

#ifdef SERVO64K
	#define FE_RATE	65536
#endif
#ifdef SERVO32K
	#define FE_RATE	32768
#endif
#ifdef SERVO16K
	#define FE_RATE	16384
#endif
#ifdef SERVO4K
	#define FE_RATE	4096
#endif
#ifdef SERVO2K
	#define FE_RATE	2048
#endif


/* Hardware configuration */
CDS_CARDS cards_used[] = {
	{GSC_16AI64SSA,0        },
	{GSC_16AO16,0      },
};

double adc_filter_00 = 0.0;
double adc_filter_01 = 0.0;
double adc_filter_02 = 0.0;
double adc_filter_03 = 0.0;
double adc_filter_04 = 0.0;
double adc_filter_05 = 0.0;
double adc_filter_06 = 0.0;
double adc_filter_07 = 0.0;
double adc_filter_sent_rfm = 0.0;
static double ground;
#define COMMDATA_INLINE
#include "commData2.h"
static int myIpcCount;
static CDS_IPC_INFO ipcInfo[2];




int feCode(int cycle, double dWord[][32],	/* ADC inputs */
		double dacOut[][16],	/* DAC outputs */
		FILT_MOD *dsp_ptr,	/* Filter Mod variables */
		COEF *dspCoeff,		/* Filter Mod coeffs */
		CDS_EPICS *pLocalEpics,	/* EPICS variables */
		int feInit)	/* Initialization flag */
{

int ii, dacFault;

if(feInit)
{
// ADC 0
dWordUsed[0][0] =  1;
dWordUsed[0][1] =  1;
dWordUsed[0][2] =  1;
dWordUsed[0][3] =  1;
dWordUsed[0][4] =  1;
dWordUsed[0][5] =  1;
dWordUsed[0][6] =  1;
dWordUsed[0][7] =  1;
// DAC number is 0
dacOutUsed[0][0] =  1;
dacOutUsed[0][1] =  1;
dacOutUsed[0][2] =  1;
dacOutUsed[0][3] =  1;
dacOutUsed[0][5] =  1;
dacOutUsed[0][6] =  1;
dacOutUsed[0][7] =  1;
dacOutUsed[0][8] =  1;
ground = 0.0;

myIpcCount = 2;

ipcInfo[0].mode = ISND;
ipcInfo[0].netType = IPCIE;
ipcInfo[0].sendRate = 16384;
ipcInfo[0].ipcNum = 3;
ipcInfo[0].errFlag = 0;
ipcInfo[0].name = "K1:SUS-X15_ADC00";
ipcInfo[0].senderModelName = "k1sus";
ipcInfo[1].mode = IRCV;
ipcInfo[1].netType = IPCIE;
ipcInfo[1].sendRate = 16384;
ipcInfo[1].ipcNum = 2;
ipcInfo[1].errFlag = 0;
ipcInfo[1].name = "K1:X15-SUS_ADC00";
ipcInfo[1].senderModelName = "k1x15";

commData2Init(myIpcCount, FE_RATE, ipcInfo);

} else {
// Enabling DAC outs for those who don't have DAC KILL WD 
dacFault = 1;

commData2Receive(myIpcCount, ipcInfo, timeSec , cycle);

// FILTER MODULE:  ADC_FILTER_00
adc_filter_00 = filterModuleD(dsp_ptr,dspCoeff,ADC_FILTER_00,dWord[0][0],0,0);

// FILTER MODULE:  ADC_FILTER_01
adc_filter_01 = filterModuleD(dsp_ptr,dspCoeff,ADC_FILTER_01,dWord[0][1],0,0);

// FILTER MODULE:  ADC_FILTER_02
adc_filter_02 = filterModuleD(dsp_ptr,dspCoeff,ADC_FILTER_02,dWord[0][2],0,0);

// FILTER MODULE:  ADC_FILTER_03
adc_filter_03 = filterModuleD(dsp_ptr,dspCoeff,ADC_FILTER_03,dWord[0][3],0,0);

// FILTER MODULE:  ADC_FILTER_04
adc_filter_04 = filterModuleD(dsp_ptr,dspCoeff,ADC_FILTER_04,dWord[0][4],0,0);

// FILTER MODULE:  ADC_FILTER_05
adc_filter_05 = filterModuleD(dsp_ptr,dspCoeff,ADC_FILTER_05,dWord[0][5],0,0);

// FILTER MODULE:  ADC_FILTER_06
adc_filter_06 = filterModuleD(dsp_ptr,dspCoeff,ADC_FILTER_06,dWord[0][6],0,0);

// FILTER MODULE:  ADC_FILTER_07
adc_filter_07 = filterModuleD(dsp_ptr,dspCoeff,ADC_FILTER_07,dWord[0][7],0,0);




// IPCx:  K1:SUS-X15_ADC00
ipcInfo[0].data = adc_filter_00;

// IPCx RCVR DIAGNOSTICS:  K1:X15-SUS_ADC00
if(!cycle && ipcInfo[1].errTotal) {
	pLocalEpics->sus.X15_SUS_ADC00_ET = timeSec;
	pLocalEpics->sus.X15_SUS_ADC00_ER = ipcInfo[1].errTotal;
	pLocalEpics->sus.X15_SUS_ADC00_PS = 0;
} 
if(!cycle && pLocalEpics->epicsInput.ipcDiagReset) { 
	 pLocalEpics->sus.X15_SUS_ADC00_PS = 1;
	 pLocalEpics->sus.X15_SUS_ADC00_ET = 0;
	 pLocalEpics->sus.X15_SUS_ADC00_ER = 0;
} 



// FILTER MODULE:  ADC_FILTER_SENT_RFM
adc_filter_sent_rfm = filterModuleD(dsp_ptr,dspCoeff,ADC_FILTER_SENT_RFM,ipcInfo[1].data,0,0);

// DAC number is 0
dacOut[0][0] = adc_filter_00;
dacOut[0][1] = adc_filter_01;
dacOut[0][2] = adc_filter_02;
dacOut[0][3] = adc_filter_03;
dacOut[0][5] = adc_filter_sent_rfm;
dacOut[0][6] = adc_filter_06;
dacOut[0][7] = adc_filter_07;
dacOut[0][8] = adc_filter_00;

    // Unit delays
    // All IPC outputs
    if (_ipc_shm != 0) {
    }
      if(!cycle && pLocalEpics->epicsInput.ipcDiagReset) pLocalEpics->epicsInput.ipcDiagReset = 0;

    commData2Send(myIpcCount, ipcInfo, timeSec, cycle);

  }
  return(dacFault);

}
#include "/opt/rtcds/rtscore/tags/advLigoRTS-2.6.3/src/fe/controller.c"
