#ifndef K1X15_H_INCLUDED
#define K1X15_H_INCLUDED
#define SYSTEM_NAME_STRING_LOWER "k1x15"
#define ADC_FILTER_00 	 0
#define ADC_FILTER_01 	 1
#define ADC_FILTER_02 	 2
#define ADC_FILTER_03 	 3
#define ADC_FILTER_04 	 4
#define ADC_FILTER_05 	 5
#define ADC_FILTER_06 	 6
#define ADC_FILTER_07 	 7
#define ADC_FILTER_08 	 8
#define ADC_FILTER_09 	 9
#define ADC_FILTER_10 	 10
#define ADC_FILTER_11 	 11
#define ADC_FILTER_12 	 12
#define ADC_FILTER_13 	 13
#define ADC_FILTER_14 	 14
#define ADC_FILTER_15 	 15
#define ADC_FILTER_SENT 	 16
#define ADC_FILTER_SENT1 	 17
#define ADC_FILTER_SENT_RFM 	 18
#define ADC_FILTER_TEST 	 19
#define MAX_FIR 	 0
#define MAX_FIR_POLY 	 0

#define BUILD_SVN_VERSION_NO 	 "3398M"

typedef struct CDS_EPICS_IN {
	int vmeReset;
	int ipcDiagReset;
	int burtRestore;
	int dcuId;
	int diagReset;
	int dacDuoSet;
	int overflowReset;
} CDS_EPICS_IN;

typedef struct CDS_EPICS_OUT {
	int epicsSync;
	int timeErr;
	int adcWaitTime;
	int diagWord;
	int timeDiag;
	int cpuMeter;
	int cpuMeterMax;
	int gdsMon[32];
	int diags[15];
	int overflowAdc[12][32];
	int overflowDac[12][16];
	int dacValue[12][16];
	int ovAccum;
	int statAdc[16];
	int statDac[16];
	int awgtpmanGPS;
	int tpCnt;
	int stateWord;
	int dcuId;
	int cycle;
} CDS_EPICS_OUT;

typedef struct X15 {
	int SUS_X15_ADC00_ER;
	int SUS_X15_ADC00_ET;
	int SUS_X15_ADC00_PS;
	int X17_X15_ADC00_ER;
	int X17_X15_ADC00_ET;
	int X17_X15_ADC00_PS;
	int X17_X15_ADC00_RFM_ER;
	int X17_X15_ADC00_RFM_ET;
	int X17_X15_ADC00_RFM_PS;
} X15;



#define MAX_MODULES 	 20
#define MAX_FILTERS 	 200

typedef struct CDS_EPICS {
	CDS_EPICS_IN epicsInput;
	CDS_EPICS_OUT epicsOutput;
	X15 x15;
} CDS_EPICS;
#define TARGET_HOST_NAME k1lsc
#endif
