#ifndef K1X16_H_INCLUDED
#define K1X16_H_INCLUDED
#define SYSTEM_NAME_STRING_LOWER "k1x16"
#define ADC_FILTER_00 	 0
#define ADC_FILTER_01 	 1
#define MAX_FIR 	 0
#define MAX_FIR_POLY 	 0

#define BUILD_SVN_VERSION_NO 	 "3398M"

typedef struct CDS_EPICS_IN {
	int vmeReset;
	int ipcDiagReset;
	int burtRestore;
	int dcuId;
	int diagReset;
	int dacDuoSet;
	int overflowReset;
} CDS_EPICS_IN;

typedef struct CDS_EPICS_OUT {
	int epicsSync;
	int timeErr;
	int adcWaitTime;
	int diagWord;
	int timeDiag;
	int cpuMeter;
	int cpuMeterMax;
	int gdsMon[32];
	int diags[15];
	int overflowAdc[12][32];
	int overflowDac[12][16];
	int dacValue[12][16];
	int ovAccum;
	int statAdc[16];
	int statDac[16];
	int awgtpmanGPS;
	int tpCnt;
	int stateWord;
	int dcuId;
	int cycle;
} CDS_EPICS_OUT;

typedef struct X16 {
	double MADC0_EPICS_CH0;
	double MADC0_EPICS_CH1;
	double TDS_MON;
} X16;



#define MAX_MODULES 	 2
#define MAX_FILTERS 	 20

typedef struct CDS_EPICS {
	CDS_EPICS_IN epicsInput;
	CDS_EPICS_OUT epicsOutput;
	X16 x16;
} CDS_EPICS;
#define TARGET_HOST_NAME k1asc
#endif
