#ifndef K1X17_H_INCLUDED
#define K1X17_H_INCLUDED
#define SYSTEM_NAME_STRING_LOWER "k1x17"
#define ADC_FILTER_00 	 0
#define ADC_FILTER_01 	 1
#define ADC_FILTER_02 	 2
#define ADC_FILTER_03 	 3
#define ADC_FILTER_04 	 4
#define ADC_FILTER_05 	 5
#define ADC_FILTER_06 	 6
#define ADC_FILTER_07 	 7
#define ADC_FILTER_SENT 	 8
#define ADC_FILTER_SENT_RFM 	 9
#define MAX_FIR 	 0
#define MAX_FIR_POLY 	 0

#define BUILD_SVN_VERSION_NO 	 "3398M"

typedef struct CDS_EPICS_IN {
	int vmeReset;
	int ipcDiagReset;
	int burtRestore;
	int dcuId;
	int diagReset;
	int dacDuoSet;
	int overflowReset;
} CDS_EPICS_IN;

typedef struct CDS_EPICS_OUT {
	int epicsSync;
	int timeErr;
	int adcWaitTime;
	int diagWord;
	int timeDiag;
	int cpuMeter;
	int cpuMeterMax;
	int gdsMon[32];
	int diags[15];
	int overflowAdc[12][32];
	int overflowDac[12][16];
	int dacValue[12][16];
	int ovAccum;
	int statAdc[16];
	int statDac[16];
	int awgtpmanGPS;
	int tpCnt;
	int stateWord;
	int dcuId;
	int cycle;
} CDS_EPICS_OUT;

typedef struct X17 {
	int X15_X17_ADC00_ER;
	int X15_X17_ADC00_ET;
	int X15_X17_ADC00_PS;
	int X15_X17_ADC00_RFM_ER;
	int X15_X17_ADC00_RFM_ET;
	int X15_X17_ADC00_RFM_PS;
} X17;



#define MAX_MODULES 	 10
#define MAX_FILTERS 	 100

typedef struct CDS_EPICS {
	CDS_EPICS_IN epicsInput;
	CDS_EPICS_OUT epicsOutput;
	X17 x17;
} CDS_EPICS;
#define TARGET_HOST_NAME k1asc
#endif
